<?php

    session_start();
    $admin_root = "..";
    $site_root = "../..";
    $path = "$admin_root/localization";

    // ====== Load Functions Libraries ======

    require "$admin_root/repository/functions.php";
    require "$admin_root/repository/cms.php";
    require "$admin_root/repository/xml.php";
    $login = "$admin_root/login.php";
    require "$admin_root/modules/_security.php";

?>

<!doctype html>
<html lang='<?php echo $_SESSION["admin_lang"]; ?>'>
	<head>
		<meta charset="UTF-8">
		<title>Localization editor</title>
        
		<link href='http://fonts.googleapis.com/css?family=Lato:100,300,400,700,900|Inconsolata:400,700|Audiowide&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
        <link rel="stylesheet" type="text/css" href="../style/foundation-icons.css" />
        <style>
            * {
                margin: 0; padding: 0;
                font-family: "Lato", sans-serif;
                font-size: 14px;
                -webkit-box-sizing: border-box; /* Safari/Chrome, other WebKit */
                -moz-box-sizing: border-box;    /* Firefox, other Gecko */
                box-sizing: border-box;         /* Opera/IE 8+ */
            }
            #files_list, #keys_list { float: left; height: 100%; min-height: 100vh; margin: 0; padding: 0; }
            #files_list { width: 140px; }
            #keys_list { width: 210px; border: 1px solid #aaa; border-style: none solid none solid; }
            dl { list-style: none; margin: 0; padding: 0; }
            dl dt, dl dd { display: block; padding: 2px 10px; border-bottom: 1px solid #ddd; }
            dl dt { font-weight: bold; color: #888; background-color: #eee; }
            dl dd { cursor: pointer; }
            dl dd:hover { background-color: #eee; }
            dl dd.new { font-weight: 900; }
            .current, .current:hover { background-color: #46d6ce; color: #fff; }
            
            #editor { overflow: hidden; }
            #editor .edit { padding: 10px; display: none; }
            #editor .edit label { display: block; padding-bottom: 10px; color: #46d6ce; font-weight: bold; }
            #editor .edit textarea { width: 100%; min-height: 120px; padding: 5px; background-color: transparent; }
            
            #files_list, #keys_list, #editor { padding-top: 50px; }
            
            header { position: fixed; top: 0; left: 0; width: 100%; height: 50px; background-color: #fff; box-shadow: 0 0 10px rgba(0,0,0,0.2); }
            header h1 { padding: 10px; float: left; margin-right: 50px; font-size: 1.5em; }
            #search { display: block; padding: 12px 0; float: left; }
            #search input, header button { padding: 2px 5px; }
            nav { float: right; padding: 12px; }
            
            #output { clear: both; padding: 10px; background-color: #ddd; display: none; }
            #output input, #output textarea { width: 100%; padding: 5px; }
            
        </style>
        <script src="../repository/jquery-3.5.1.min.js"></script>
        <script src="../repository/jquery-ui.min.js"></script>
        <script src="../repository/jquery.ui.touch-punch.min.js"></script>
        <script src="../repository/functions.js<?php echo "?v=".$last_update; ?>"></script>
    </head>
    <body>
          
<?php

    //echo "<h1>Localization editor</h1><hr>\n";
    $files_list = listDir($path, "json");

    echo "<script>\n";
    echo "\tvar LOCALIZATIONS = {};\n";
    foreach($files_list as $file) {
        $json = preg_replace("/\s+/", " ", file_get_contents("$path/$file"));
        $filename = path($file, "filename");
        echo "\tLOCALIZATIONS[\"$filename\"] = ".$json.";\n";
    }
    echo "</script>\n";
    //arrayList($localization);
              
    echo "<div id='files_list'>\n";
    echo "\t<dl>\n";
    echo "\t\t<dt>Files</dt>\n";
    //foreach($files_list as $file) {
    //    $filename = path($file, "filename");
    //    echo "\t\t<dd>".$filename."</dd>\n";
    //}
    echo "\t</dl>\n";
    echo "</div>\n";

    echo "<div id='keys_list'>\n";
    echo "\t<dl>\n";
    echo "\t\t<dt>Keys</dt>\n";
    echo "\t</dl>\n";
    echo "</div>\n";
        
    echo "<div id='editor'>\n";
    echo "\t<dl>\n";
    echo "\t\t<dt>Translations</dt>\n";
    $settings = loadXml("$site_root/settings.xml", "draft");
    foreach($settings["multi_language"] as $language) {
        $language = $language["id"][0]["string"][0];

        echo "\t<dd class='edit lang-$language'>\n";
        echo "\t\t<label>$language</label>\n";
        echo "\t\t<textarea></textarea>\n";
        echo "\t</dd>\n";
    }
    echo "\t</dl>\n";
    echo "</div>\n";
?> 
        <form id='output' method='post'>
            <textarea name='json' placeholder='json'></textarea>
        </form>
        
        <header>
            <h1>Localization editor</h1>
            <form id='search'>
                <input type='text'>
                <button class='fi-magnifying-glass'></button>
            </form>
            <nav>
                <button class='save' onclick="self.close()">&nbsp;&nbsp;Save&nbsp;&nbsp;</button>
                <button class='close' onclick="self.close()">X</button>
            </nav>
        </header>
        
        <script src="99_localization_editor.js?v=<?php echo uniqid(); ?>"></script>
    </body>
</html>