// ==========================================
//                Translate
// ==========================================

function lauchDictionary() {
    for(key in DICTIONARY) {
        text = DICTIONARY[key];
        DICTIONARY[ key.capitalize() ] = text.capitalize();
        DICTIONARY[ key.toUpperCase() ] = text.toUpperCase();
        DICTIONARY[ key.toLowerCase() ] = text.toLowerCase();
    }
    // Auto translate media types
    $("div.set span").each(function() {
        $(this).html( translate($(this).html()) );
    }); 
};

function translate(text) { // used in: setButtons()
// --------------------------------
// text = <string>
// --------------------------------
// RETURNS: <string> Translation based on dictionary
// --------------------------------
    for(word in DICTIONARY) {
        find = new RegExp(word, "g");
        text = text.replace(find, DICTIONARY[word]);
    };
    return text;
};

// ==========================================
//                 Languages
// ==========================================

function launchLanguages() {
    $("form").append("<input type='hidden' id='language_set' name='language_set' value=''>");

    // Fill missing language tags based on default language data
    $("form section div.text").each(function() {
        $deflt = $(this).find("." + ADMIN_LANG);
        if($deflt.length) {
            deflt_html = $deflt.get(0).outerHTML;
            if($deflt.prop("tagName") == "TEXTAREA") {
                deflt_html = deflt_html.replace(/<textarea (.*?)>(.*?)<\/textarea>/, "<textarea $1></textarea>");
            }
            else { // INPUT
                deflt_html = deflt_html.replace(/ value=\"(.*?)\"/, " value=\"\"");
            };
            for(i = 0; i < LANGUAGES.length; i++) {
                $lang_content = $(this).find("." + LANGUAGES[i]);
                if(!$lang_content.length) {
                    deflt_html = deflt_html.replace("class=\"" + ADMIN_LANG + "\"", "class=\"" + LANGUAGES[i] + "\"");
                    $(this).append( deflt_html );
                };
            };
        };
    });

    // Initialize language menu (if more than one language exists)
    if(LANGUAGES.length > 1) {
        $("#lang ul").mouseenter(function() {
            $("#lang li").stop().show(200);
            $("body").append("<div id='page_fader_trans'></div>");
            $("#page_fader_trans").fadeIn(ANIMATION_TIME);
            // Mobile hide by click
            $("#page_fader_trans").click(function() {
                hideShowLangMenu(200);
            });
        })
        $("#lang ul").mouseleave(function() {
            hideShowLangMenu(200);

        });

        $("#lang li").click(function() {
            LANG = $(this).attr("value");
            changeLanguage(200);
            //setTimeout(function() { hideShowLangMenu(200); }, 300);
            //urlQuery("lang=" + lang);
        });
    };
    
    $("#lang > span").click(function() { showAllLanguages($(this)); })
};

function hideShowLangMenu(time) {
// --------------------------------
// LANG = <string> !Global
// --------------------------------
// Show only the current language in menu
// --------------------------------
    if(time == undefined) { time = 0; };
    $("#lang li").each(function() {
        if($(this).attr("value") == LANG) {
            $(this).show(time);
        }
        else {
            $(this).hide(time);
        };
    });
    $("#page_fader_trans").fadeOut(ANIMATION_TIME, function() { $(this).remove() });
};

function showAllLanguages($button) {
    if($button.attr("class").indexOf("show_all") > -1) {
        $button.removeClass("show_all").attr("help", LOCALIZE["language-show-selected"]);
        active_languages = [];
        $("#lang li").each(function() { active_languages[active_languages.length] = $(this).attr("value"); });
        $("form .text input, form .text textarea, form .table table").each(function() {
            if($(this).closest("article").attr("class").substr(0, 1) != "_") {
                language = $(this).attr("class");
                if(active_languages.indexOf(language) > -1) { $(this).slideDown(250); }
            }
        });
        initializeHelp();
    }
    else {
        $button.addClass("show_all").attr("help", LOCALIZE["language-show-all"]);
        $("form .text input, form .text textarea, form .table table").each(function() {
            if($(this).closest("article").attr("class").substr(0, 1) != "_") {
                language = $(this).attr("class");
                if(language != LANG) { $(this).slideUp(250); }
            }
        });
        initializeHelp();
    }
};

function changeLanguage(time) {
// --------------------------------
// LANG = <string> !Global
// --------------------------------
// Show only the current language content
// --------------------------------
    if(time == undefined) { time = 0; };
    $("#lang li").stop();
    $("form article").animate({ "opacity": "0" }, time, function() {
        $("form .text input, form .text textarea, form .table table").each(function() {
            if($(this).closest("article").attr("class").substr(0, 1) != "_") { // only for xml
                language = $(this).attr("class");
                if(language == LANG) { $(this).show(); }
                else { $(this).hide(); };
            };
        });
        $("form article").animate({ "opacity": "1" }, time);
    });

    // Navigation & order titles
    $("span.lang_title").each(function() {
        item_lang = $(this).attr("class").split(" ").pop();
        if(LANG == item_lang) { $(this).show(); } else { $(this).hide(); };
    })

    // Update output -> back from publish
    $("input#language_set").val(LANG);

    urlQuery("+lang=" + LANG);

    // Update HTML lang data
    $("input#current_edit_lang").val(LANG);

    //hideShowLangMenu();
    initializeDectectChanges();
};