<?php

    session_start();

    // ====== Load Functions Libraries ======

    require "admin/repository/functions.php";
    require "admin/repository/cms.php";
    require "admin/repository/xml.php";

?>

<!doctype html>
<html lang='en'>
	<head>
		<meta charset="UTF-8">
		<title>X.able CMS / Xable Jable</title>
		<link href='http://fonts.googleapis.com/css?family=Lato:100,300,400,700,900|Inconsolata:400,700|Audiowide&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
        <link rel="stylesheet" type="text/css" href="<?php echo "admin/_tools/_tools.css" ?>" />
        <style></style>
    </head>
    <body>
        <button class='close' onclick="self.close()">X</button>
        
<?php
    
    function xmlToJson($path, $backup_folder) {
        $xml = join(" ", array_map("trim", file($path)));
        $xml = xmlToArray($xml);
        if(is_array($xml)) {
            if(array_shift(array_keys($xml)) == "xable") { $xml = $xml['xable'][0]; };
            $json = arrayToJson($xml);
            if($json && json_decode($json)) {
                $dir = path($path, "dirname");
                if($dir && $dir != "") { $dir = $dir."/"; };
                $new_path = $dir.str_replace(".xml", ".json", path($path, "basename"));
                $bak_path = $backup_folder."/".str_replace("/", "%", $path);
                echo "Saved: $path -> $new_path | BAK: $bak_path<br>\n";
                //echo "<textarea style='width:100%;height:auto'>".$json."</textarea><br>\n";
            }
            else {
                echo "#ERROR! Conversion to JSON failed: $path<br>\n";
            }
        }
        else {
            echo "#ERROR! Not valid XML: $path<br>\n";
        }
    };
              


    echo "<h1>Xable Jable 4to5 converter</h1><hr>\n";
    if(isset($_POST["action"]) && $_POST["action"] == "json") {
        
        $backup_folder = "tmp/xable-jable";
        
        echo "<b>XML -> JSON</b><hr>\n";
        makeDir($backup_folder);
        $xable_ext = [ "draft", "prev", "xml", "order", "template" ];
        foreach(listDir("", ".,?") as $path) {
            $ext = path($path, "extension");
            if(in_array($ext, $xable_ext) && path($path, "filename") != "browserconfig") {
                
                $json = xmlToJson($path, $backup_folder);
            }
        }
        foreach(filesTree("pages", ".") as $path) {
            $ext = path($path, "extension");
            if(in_array($ext, $xable_ext)) {
                $json = xmlToJson($path, $backup_folder);
            }
        }
        
        echo "<hr><b>Edit INI files</b><hr>\n";
        $ini_pathes = array_merge([ "admin/xable.ini" ], listDir("admin/_users", "ini,?"));
        foreach($ini_pathes as $path) {
            echo "[$path]<br>\n";
            $content = array_map("trim", explode("\n", file_get_contents($path)));
            //echo "<textarea>".join("\n", $ini)."</textarea><br>\n";
            foreach(array_keys($content) as $i) {
                $text = $content[$i];
                if(strstr($text, "=") && strstr($text, ".xml")) {
                    $text = str_replace(".xml", ".json", $text);
                    $content[$i] = $text;
                    echo "> $text<br>\n";
                }
            }
            $bak_path = $backup_folder."/".str_replace("/", "%", $path);
        }
        
        echo "<hr><b>Update site xml.php version</b><hr>\n";
        $new_path = "admin/repository/xml.php";
        $path = "script/xml.php";
        $bak_path = $backup_folder."/".str_replace("/", "%", $path);
        echo "$new_path -> $path [ BAK: $bak_path ]<br>\n";

        echo "<hr><b>Update launcher.php</b><hr>\n";
        $path = "modules/launcher.php";
        if(file_exists($path)) {
            $content = array_map("trim", explode("\n", file_get_contents($path)));
            foreach(array_keys($content) as $i) {
                $text = $content[$i];
                if(strstr($text, ".xml\"")) {
                    $text = str_replace(".xml\"", ".json\"", $text);
                    $content[$i] = $text;
                    echo "> $text<br>\n";
                }
            }
            $bak_path = $backup_folder."/".str_replace("/", "%", $path);
        };
        
        echo "<hr><b>Start X.able update</b><hr>\n";
        if(file_exists("unzip.php.txt")) { rename("unzip.php.txt", "unzip.php"); }
        if(file_exists("unzip.php")) {
            echo "<a href='unzip.php'>unzip.php</a><br>\n";
        }
        else {
            echo "\"unzip.php\" file not found.<br>Upload Xable 5+ installer + unzip & perform update.<br>\n";
        }
        
    }
    else {
        echo "<form method='post'>\n";
        echo "<p>Convert site content to JSON format:</p>\n";
        echo "<p>- Upload this tool, Xable 5+ installer & unzip.php to your FTP root folder<br>- Launch this tool<br>- Perform Xable 5+ update<br>- Make the necessary manual site code mods</p>\n";
        echo "<button name='action' value='json' type='submit'>Submit</button>\n";
        echo "</form>\n";
    };

?> 
        
    </body>
</html>